package net.thegreshams.gosuZfsUtility.impl

uses java.util.logging.Logger

uses net.thegreshams.gosuZfsUtility.*
uses gw.util.CommandFailedException

class GosuZfsShellImpl implements GosuZfsShell {

	final static var LOGGER = Logger.getLogger( GosuZfsShellImpl.Type.Name )
	final static var LOGGER_ENTRY = "ENTRY"
	final static var LOGGER_EXIT = "EXIT"
	final static var LOGGER_EXECUTING = "EXECUTING: "	

	construct() {
	    LOGGER.info( LOGGER_ENTRY )
	    
	    LOGGER.info( LOGGER_EXIT )
	}

	override function execute( shellCommand : String) : String {
	    
	    var result = ""
	    LOGGER.info( LOGGER_ENTRY )
	    
	    if( shellCommand.trim().HasContent ) {
	        
	        shellCommand = shellCommand.trim()
	        LOGGER.info( LOGGER_EXECUTING + shellCommand )
	        
	        try {
	            
	    		result = gw.util.Shell.exec( shellCommand )
	    		
	        } catch( cfe : CommandFailedException ) {
	            
	            LOGGER.warning( cfe.Message )
	            result = ""
	            
	        }
	    	
	    } else {
	        
	        LOGGER.warning( "${LOGGER_EXECUTING}<nothing to execute>" )
	        LOGGER.warning( "Unable to execute the following received shellCommand: '${shellCommand}'." )
	        
	    }
	    
	    LOGGER.info( LOGGER_EXIT )
	    return result
	}
	
}
